<Feature xmlns="http://www.sila-standard.org" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" Category="databases" FeatureVersion="1.0" MaturityLevel="Draft" Originator="de.unigreifswald" SiLA2Version="1.0" xsi:schemaLocation="http://www.sila-standard.org https://gitlab.com/SiLA2/sila_base/raw/master/schema/FeatureDefinition.xsd">
  <Identifier>InfluxDBController</Identifier>
  <DisplayName>InfluxDB Controller</DisplayName>
  <Description>InfluxDB Controller</Description>
  <Command>
    <Identifier>CreateToken</Identifier>
    <DisplayName>Create New Token</DisplayName>
    <Description>Create New Token for InfluxDB</Description>
    <Observable>No</Observable>
    <Parameter>
      <Identifier>Token</Identifier>
      <DisplayName>Token</DisplayName>
      <Description>InfluxDB access token</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Parameter>
  </Command>
  <Command>
    <Identifier>SetToken</Identifier>
    <DisplayName>Set Token</DisplayName>
    <Description>Set Token for InfluxDB</Description>
    <Observable>No</Observable>
    <Parameter>
      <Identifier>Token</Identifier>
      <DisplayName>Token</DisplayName>
      <Description>InfluxDB access token</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Parameter>
  </Command>
  <Command>
    <Identifier>SetOrganisation</Identifier>
    <DisplayName>Set Organisation</DisplayName>
    <Description>Set Organisation in InFluxDB</Description>
    <Observable>No</Observable>
    <Parameter>
      <Identifier>Organisation</Identifier>
      <DisplayName>Organisation Name</DisplayName>
      <Description>Name of the Organisation</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Parameter>
  </Command>
  <Command>
    <Identifier>SetBucket</Identifier>
    <DisplayName>Set Bucket</DisplayName>
    <Description>Set InfluxDB bucket</Description>
    <Observable>No</Observable>
    <Parameter>
      <Identifier>Bucket</Identifier>
      <DisplayName>Bucket Name</DisplayName>
      <Description>Name of the InfluxDB Bucket</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Parameter>
  </Command>
  <Command>
    <Identifier>QueryInfluxDB</Identifier>
    <DisplayName>Query InfluxDB</DisplayName>
    <Description>Query InfluxDB in flux query language</Description>
    <Observable>No</Observable>
    <Parameter>
      <Identifier>Query</Identifier>
      <DisplayName>Flux Query</DisplayName>
      <Description>Flux Query</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Parameter>
    <Parameter>
      <Identifier>QueryResultType</Identifier>
      <DisplayName>Query Result Type</DisplayName>
      <Description>Type of Query Result (JSON, Pandas Dataframe, ...)</Description>
      <DataType>
        <!-- should be enum in the future-->
        <Basic>String</Basic>
      </DataType>
    </Parameter>
    <Response>
      <Identifier>QueryResult</Identifier>
      <DisplayName>Query Result</DisplayName>
      <Description>Result of query</Description>
      <DataType>
        <Basic>String</Basic>
      </DataType>
    </Response>
  </Command>
  <Property>
    <Identifier>Token</Identifier>
    <DisplayName>Current InfluxDB Token</DisplayName>
    <Description>Get Current InfluxDB Token</Description>
    <Observable>No</Observable>
    <DataType>
      <Basic>String</Basic>
    </DataType>
  </Property>
  <Property>
    <Identifier>Organisation</Identifier>
    <DisplayName>Current InfluxDB Organisation</DisplayName>
    <Description>Get Current InfluxDB Organisation</Description>
    <Observable>No</Observable>
    <DataType>
      <Basic>String</Basic>
    </DataType>
  </Property>
  <Property>
    <Identifier>Bucket</Identifier>
    <DisplayName>Current InfluxDB Bucket</DisplayName>
    <Description>Get Current InfluxDB Bucket</Description>
    <Observable>No</Observable>
    <DataType>
      <Basic>String</Basic>
    </DataType>
  </Property>
</Feature>
